/* SaveDialog.c generated by valac 0.56.17, the Vala compiler
 * generated from SaveDialog.vala, do not modify */

/*
* Copyright (c) 2014–2016 Fabio Zaramella <ffabio.96.x@gmail.com>
*               2017–2022 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Artem Anufrij <artem.anufrij@live.de>
*              Fabio Zaramella <ffabio.96.x@gmail.com>
*/

#include <granite.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define SCREENSHOT_APPLICATION_SAVE_FOLDER _ ("Screenshots")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SCREENSHOT_TYPE_SAVE_DIALOG (screenshot_save_dialog_get_type ())
#define SCREENSHOT_SAVE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialog))
#define SCREENSHOT_SAVE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialogClass))
#define SCREENSHOT_IS_SAVE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREENSHOT_TYPE_SAVE_DIALOG))
#define SCREENSHOT_IS_SAVE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREENSHOT_TYPE_SAVE_DIALOG))
#define SCREENSHOT_SAVE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialogClass))

typedef struct _ScreenshotSaveDialog ScreenshotSaveDialog;
typedef struct _ScreenshotSaveDialogClass ScreenshotSaveDialogClass;
typedef struct _ScreenshotSaveDialogPrivate ScreenshotSaveDialogPrivate;
enum  {
	SCREENSHOT_SAVE_DIALOG_0_PROPERTY,
	SCREENSHOT_SAVE_DIALOG_PIXBUF_PROPERTY,
	SCREENSHOT_SAVE_DIALOG_SETTINGS_PROPERTY,
	SCREENSHOT_SAVE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* screenshot_save_dialog_properties[SCREENSHOT_SAVE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	SCREENSHOT_SAVE_DIALOG_SAVE_RESPONSE_SIGNAL,
	SCREENSHOT_SAVE_DIALOG_NUM_SIGNALS
};
static guint screenshot_save_dialog_signals[SCREENSHOT_SAVE_DIALOG_NUM_SIGNALS] = {0};

struct _ScreenshotSaveDialog {
	GraniteDialog parent_instance;
	ScreenshotSaveDialogPrivate * priv;
};

struct _ScreenshotSaveDialogClass {
	GraniteDialogClass parent_class;
};

struct _ScreenshotSaveDialogPrivate {
	GdkPixbuf* _pixbuf;
	GSettings* _settings;
};

struct _Block6Data {
	int _ref_count_;
	ScreenshotSaveDialog* self;
	gchar* folder_dir;
	gchar* file_name;
	GraniteValidatedEntry* name_entry;
	GtkLabel* validation_label;
	GtkRevealer* name_message_revealer;
	GtkComboBoxText* format_cmb;
	GtkFileChooserButton* location;
	GtkButton* save_btn;
};

static gint ScreenshotSaveDialog_private_offset;
static gpointer screenshot_save_dialog_parent_class = NULL;

VALA_EXTERN GType screenshot_save_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenshotSaveDialog, g_object_unref)
VALA_EXTERN ScreenshotSaveDialog* screenshot_save_dialog_new (GdkPixbuf* pixbuf,
                                                  GSettings* settings,
                                                  GtkWindow* parent);
VALA_EXTERN ScreenshotSaveDialog* screenshot_save_dialog_construct (GType object_type,
                                                        GdkPixbuf* pixbuf,
                                                        GSettings* settings,
                                                        GtkWindow* parent);
VALA_EXTERN GdkPixbuf* screenshot_save_dialog_get_pixbuf (ScreenshotSaveDialog* self);
static void screenshot_save_dialog_set_pixbuf (ScreenshotSaveDialog* self,
                                        GdkPixbuf* value);
VALA_EXTERN GSettings* screenshot_save_dialog_get_settings (ScreenshotSaveDialog* self);
static void screenshot_save_dialog_set_settings (ScreenshotSaveDialog* self,
                                          GSettings* value);
static void g_cclosure_user_marshal_VOID__BOOLEAN_STRING_STRING_STRING (GClosure * closure,
                                                                 GValue * return_value,
                                                                 guint n_param_values,
                                                                 const GValue * param_values,
                                                                 gpointer invocation_hint,
                                                                 gpointer marshal_data);
static GObject * screenshot_save_dialog_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN void screenshot_application_create_dir_if_missing (const gchar* path);
static void _screenshot_save_dialog___lambda5_ (ScreenshotSaveDialog* self,
                                         GtkWidget* widget,
                                         GdkDragContext* context,
                                         GtkSelectionData* selection_data,
                                         guint info,
                                         guint time_);
static void __screenshot_save_dialog___lambda5__gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   GtkSelectionData* selection_data,
                                                                   guint info,
                                                                   guint time_,
                                                                   gpointer self);
static void _screenshot_save_dialog___lambda6_ (Block6Data* _data6_);
static void __screenshot_save_dialog___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                               gpointer self);
static void _screenshot_save_dialog___lambda7_ (Block6Data* _data6_);
static void __screenshot_save_dialog___lambda7__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _screenshot_save_dialog___lambda8_ (ScreenshotSaveDialog* self);
static void __screenshot_save_dialog___lambda8__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _screenshot_save_dialog___lambda9_ (Block6Data* _data6_);
static void __screenshot_save_dialog___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _screenshot_save_dialog___lambda10_ (Block6Data* _data6_);
static void __screenshot_save_dialog___lambda10__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _screenshot_save_dialog___lambda11_ (Block6Data* _data6_);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void __screenshot_save_dialog___lambda11__gtk_file_chooser_selection_changed (GtkFileChooser* _sender,
                                                                              gpointer self);
static void screenshot_save_dialog_finalize (GObject * obj);
static GType screenshot_save_dialog_get_type_once (void);
static void _vala_screenshot_save_dialog_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_screenshot_save_dialog_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
screenshot_save_dialog_get_instance_private (ScreenshotSaveDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ScreenshotSaveDialog_private_offset);
}

ScreenshotSaveDialog*
screenshot_save_dialog_construct (GType object_type,
                                  GdkPixbuf* pixbuf,
                                  GSettings* settings,
                                  GtkWindow* parent)
{
	ScreenshotSaveDialog * self = NULL;
#line 29 "../src/Widgets/SaveDialog.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 29 "../src/Widgets/SaveDialog.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 29 "../src/Widgets/SaveDialog.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 30 "../src/Widgets/SaveDialog.vala"
	self = (ScreenshotSaveDialog*) g_object_new (object_type, "deletable", FALSE, "modal", TRUE, "pixbuf", pixbuf, "settings", settings, "title", _ ("Screenshot"), "transient-for", parent, NULL);
#line 29 "../src/Widgets/SaveDialog.vala"
	return self;
#line 209 "SaveDialog.c"
}

ScreenshotSaveDialog*
screenshot_save_dialog_new (GdkPixbuf* pixbuf,
                            GSettings* settings,
                            GtkWindow* parent)
{
#line 29 "../src/Widgets/SaveDialog.vala"
	return screenshot_save_dialog_construct (SCREENSHOT_TYPE_SAVE_DIALOG, pixbuf, settings, parent);
#line 219 "SaveDialog.c"
}

GdkPixbuf*
screenshot_save_dialog_get_pixbuf (ScreenshotSaveDialog* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 24 "../src/Widgets/SaveDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 24 "../src/Widgets/SaveDialog.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/SaveDialog.vala"
	return result;
#line 235 "SaveDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/Widgets/SaveDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 243 "SaveDialog.c"
}

static void
screenshot_save_dialog_set_pixbuf (ScreenshotSaveDialog* self,
                                   GdkPixbuf* value)
{
	GdkPixbuf* old_value;
#line 24 "../src/Widgets/SaveDialog.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/SaveDialog.vala"
	old_value = screenshot_save_dialog_get_pixbuf (self);
#line 24 "../src/Widgets/SaveDialog.vala"
	if (old_value != value) {
#line 257 "SaveDialog.c"
		GdkPixbuf* _tmp0_;
#line 24 "../src/Widgets/SaveDialog.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (self->priv->_pixbuf);
#line 24 "../src/Widgets/SaveDialog.vala"
		self->priv->_pixbuf = _tmp0_;
#line 24 "../src/Widgets/SaveDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, screenshot_save_dialog_properties[SCREENSHOT_SAVE_DIALOG_PIXBUF_PROPERTY]);
#line 267 "SaveDialog.c"
	}
}

GSettings*
screenshot_save_dialog_get_settings (ScreenshotSaveDialog* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 25 "../src/Widgets/SaveDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = self->priv->_settings;
#line 25 "../src/Widgets/SaveDialog.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/SaveDialog.vala"
	return result;
#line 284 "SaveDialog.c"
}

static void
screenshot_save_dialog_set_settings (ScreenshotSaveDialog* self,
                                     GSettings* value)
{
	GSettings* old_value;
#line 25 "../src/Widgets/SaveDialog.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/SaveDialog.vala"
	old_value = screenshot_save_dialog_get_settings (self);
#line 25 "../src/Widgets/SaveDialog.vala"
	if (old_value != value) {
#line 298 "SaveDialog.c"
		GSettings* _tmp0_;
#line 25 "../src/Widgets/SaveDialog.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (self->priv->_settings);
#line 25 "../src/Widgets/SaveDialog.vala"
		self->priv->_settings = _tmp0_;
#line 25 "../src/Widgets/SaveDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, screenshot_save_dialog_properties[SCREENSHOT_SAVE_DIALOG_SETTINGS_PROPERTY]);
#line 308 "SaveDialog.c"
	}
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_STRING_STRING_STRING (GClosure * closure,
                                                            GValue * return_value,
                                                            guint n_param_values,
                                                            const GValue * param_values,
                                                            gpointer invocation_hint,
                                                            gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_STRING_STRING_STRING) (gpointer data1, gboolean arg_1, const char* arg_2, const char* arg_3, const char* arg_4, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/Widgets/SaveDialog.vala"
	g_return_if_fail (n_param_values == 5);
#line 23 "../src/Widgets/SaveDialog.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/Widgets/SaveDialog.vala"
		data1 = closure->data;
#line 23 "../src/Widgets/SaveDialog.vala"
		data2 = param_values->data[0].v_pointer;
#line 334 "SaveDialog.c"
	} else {
#line 23 "../src/Widgets/SaveDialog.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/Widgets/SaveDialog.vala"
		data2 = closure->data;
#line 340 "SaveDialog.c"
	}
#line 23 "../src/Widgets/SaveDialog.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/Widgets/SaveDialog.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), g_value_get_string (param_values + 4), data2);
#line 346 "SaveDialog.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 40 "../src/Widgets/SaveDialog.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 40 "../src/Widgets/SaveDialog.vala"
	return _data6_;
#line 356 "SaveDialog.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 40 "../src/Widgets/SaveDialog.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 366 "SaveDialog.c"
		ScreenshotSaveDialog* self;
#line 40 "../src/Widgets/SaveDialog.vala"
		self = _data6_->self;
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (_data6_->save_btn);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (_data6_->location);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (_data6_->format_cmb);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (_data6_->name_message_revealer);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (_data6_->validation_label);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (_data6_->name_entry);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_free0 (_data6_->file_name);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_free0 (_data6_->folder_dir);
#line 40 "../src/Widgets/SaveDialog.vala"
		_g_object_unref0 (self);
#line 40 "../src/Widgets/SaveDialog.vala"
		g_slice_free (Block6Data, _data6_);
#line 390 "SaveDialog.c"
	}
}

static void
_screenshot_save_dialog___lambda5_ (ScreenshotSaveDialog* self,
                                    GtkWidget* widget,
                                    GdkDragContext* context,
                                    GtkSelectionData* selection_data,
                                    guint info,
                                    guint time_)
{
	GdkPixbuf* _tmp0_;
#line 73 "../src/Widgets/SaveDialog.vala"
	g_return_if_fail (widget != NULL);
#line 73 "../src/Widgets/SaveDialog.vala"
	g_return_if_fail (context != NULL);
#line 73 "../src/Widgets/SaveDialog.vala"
	g_return_if_fail (selection_data != NULL);
#line 74 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 74 "../src/Widgets/SaveDialog.vala"
	gtk_selection_data_set_pixbuf (selection_data, _tmp0_);
#line 413 "SaveDialog.c"
}

static void
__screenshot_save_dialog___lambda5__gtk_widget_drag_data_get (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkSelectionData* selection_data,
                                                              guint info,
                                                              guint time_,
                                                              gpointer self)
{
#line 73 "../src/Widgets/SaveDialog.vala"
	_screenshot_save_dialog___lambda5_ ((ScreenshotSaveDialog*) self, _sender, context, selection_data, info, time_);
#line 426 "SaveDialog.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 445 "SaveDialog.c"
}

static void
_screenshot_save_dialog___lambda6_ (Block6Data* _data6_)
{
	ScreenshotSaveDialog* self;
	GraniteValidatedEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkRevealer* _tmp13_;
	GraniteValidatedEntry* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GtkButton* _tmp17_;
	GraniteValidatedEntry* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
#line 178 "../src/Widgets/SaveDialog.vala"
	self = _data6_->self;
#line 179 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = _data6_->name_entry;
#line 179 "../src/Widgets/SaveDialog.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 179 "../src/Widgets/SaveDialog.vala"
	_tmp2_ = _tmp1_;
#line 179 "../src/Widgets/SaveDialog.vala"
	_tmp3_ = strlen (_tmp2_);
#line 179 "../src/Widgets/SaveDialog.vala"
	_tmp4_ = _tmp3_;
#line 179 "../src/Widgets/SaveDialog.vala"
	if (_tmp4_ == 0) {
#line 479 "SaveDialog.c"
		GtkLabel* _tmp5_;
		GraniteValidatedEntry* _tmp6_;
#line 180 "../src/Widgets/SaveDialog.vala"
		_tmp5_ = _data6_->validation_label;
#line 180 "../src/Widgets/SaveDialog.vala"
		gtk_label_set_label (_tmp5_, _ ("Filename can't be blank"));
#line 181 "../src/Widgets/SaveDialog.vala"
		_tmp6_ = _data6_->name_entry;
#line 181 "../src/Widgets/SaveDialog.vala"
		granite_validated_entry_set_is_valid (_tmp6_, FALSE);
#line 490 "SaveDialog.c"
	} else {
		GraniteValidatedEntry* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 182 "../src/Widgets/SaveDialog.vala"
		_tmp7_ = _data6_->name_entry;
#line 182 "../src/Widgets/SaveDialog.vala"
		_tmp8_ = gtk_entry_get_text ((GtkEntry*) _tmp7_);
#line 182 "../src/Widgets/SaveDialog.vala"
		_tmp9_ = _tmp8_;
#line 182 "../src/Widgets/SaveDialog.vala"
		if (string_contains (_tmp9_, "/")) {
#line 503 "SaveDialog.c"
			GtkLabel* _tmp10_;
			GraniteValidatedEntry* _tmp11_;
#line 183 "../src/Widgets/SaveDialog.vala"
			_tmp10_ = _data6_->validation_label;
#line 183 "../src/Widgets/SaveDialog.vala"
			gtk_label_set_label (_tmp10_, _ ("Filename can't contain “/”"));
#line 184 "../src/Widgets/SaveDialog.vala"
			_tmp11_ = _data6_->name_entry;
#line 184 "../src/Widgets/SaveDialog.vala"
			granite_validated_entry_set_is_valid (_tmp11_, FALSE);
#line 514 "SaveDialog.c"
		} else {
			GraniteValidatedEntry* _tmp12_;
#line 186 "../src/Widgets/SaveDialog.vala"
			_tmp12_ = _data6_->name_entry;
#line 186 "../src/Widgets/SaveDialog.vala"
			granite_validated_entry_set_is_valid (_tmp12_, TRUE);
#line 521 "SaveDialog.c"
		}
	}
#line 189 "../src/Widgets/SaveDialog.vala"
	_tmp13_ = _data6_->name_message_revealer;
#line 189 "../src/Widgets/SaveDialog.vala"
	_tmp14_ = _data6_->name_entry;
#line 189 "../src/Widgets/SaveDialog.vala"
	_tmp15_ = granite_validated_entry_get_is_valid (_tmp14_);
#line 189 "../src/Widgets/SaveDialog.vala"
	_tmp16_ = _tmp15_;
#line 189 "../src/Widgets/SaveDialog.vala"
	gtk_revealer_set_reveal_child (_tmp13_, !_tmp16_);
#line 190 "../src/Widgets/SaveDialog.vala"
	_tmp17_ = _data6_->save_btn;
#line 190 "../src/Widgets/SaveDialog.vala"
	_tmp18_ = _data6_->name_entry;
#line 190 "../src/Widgets/SaveDialog.vala"
	_tmp19_ = granite_validated_entry_get_is_valid (_tmp18_);
#line 190 "../src/Widgets/SaveDialog.vala"
	_tmp20_ = _tmp19_;
#line 190 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, _tmp20_);
#line 544 "SaveDialog.c"
}

static void
__screenshot_save_dialog___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                          gpointer self)
{
#line 178 "../src/Widgets/SaveDialog.vala"
	_screenshot_save_dialog___lambda6_ (self);
#line 553 "SaveDialog.c"
}

static void
_screenshot_save_dialog___lambda7_ (Block6Data* _data6_)
{
	ScreenshotSaveDialog* self;
	const gchar* _tmp0_;
	GraniteValidatedEntry* _tmp1_;
	const gchar* _tmp2_;
	GtkComboBoxText* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 193 "../src/Widgets/SaveDialog.vala"
	self = _data6_->self;
#line 194 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = _data6_->folder_dir;
#line 194 "../src/Widgets/SaveDialog.vala"
	_tmp1_ = _data6_->name_entry;
#line 194 "../src/Widgets/SaveDialog.vala"
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
#line 194 "../src/Widgets/SaveDialog.vala"
	_tmp3_ = _data6_->format_cmb;
#line 194 "../src/Widgets/SaveDialog.vala"
	_tmp4_ = gtk_combo_box_text_get_active_text (_tmp3_);
#line 194 "../src/Widgets/SaveDialog.vala"
	_tmp5_ = _tmp4_;
#line 194 "../src/Widgets/SaveDialog.vala"
	g_signal_emit (self, screenshot_save_dialog_signals[SCREENSHOT_SAVE_DIALOG_SAVE_RESPONSE_SIGNAL], 0, TRUE, _tmp0_, _tmp2_, _tmp5_);
#line 194 "../src/Widgets/SaveDialog.vala"
	_g_free0 (_tmp5_);
#line 584 "SaveDialog.c"
}

static void
__screenshot_save_dialog___lambda7__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 193 "../src/Widgets/SaveDialog.vala"
	_screenshot_save_dialog___lambda7_ (self);
#line 593 "SaveDialog.c"
}

static void
_screenshot_save_dialog___lambda8_ (ScreenshotSaveDialog* self)
{
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	GdkPixbuf* _tmp2_;
#line 198 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 198 "../src/Widgets/SaveDialog.vala"
	_tmp1_ = gtk_clipboard_get_default (_tmp0_);
#line 198 "../src/Widgets/SaveDialog.vala"
	_tmp2_ = self->priv->_pixbuf;
#line 198 "../src/Widgets/SaveDialog.vala"
	gtk_clipboard_set_image (_tmp1_, _tmp2_);
#line 199 "../src/Widgets/SaveDialog.vala"
	g_signal_emit_by_name ((GtkDialog*) self, "close");
#line 612 "SaveDialog.c"
}

static void
__screenshot_save_dialog___lambda8__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 197 "../src/Widgets/SaveDialog.vala"
	_screenshot_save_dialog___lambda8_ ((ScreenshotSaveDialog*) self);
#line 621 "SaveDialog.c"
}

static void
_screenshot_save_dialog___lambda9_ (Block6Data* _data6_)
{
	ScreenshotSaveDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkComboBoxText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 202 "../src/Widgets/SaveDialog.vala"
	self = _data6_->self;
#line 203 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = _data6_->folder_dir;
#line 203 "../src/Widgets/SaveDialog.vala"
	_tmp1_ = _data6_->file_name;
#line 203 "../src/Widgets/SaveDialog.vala"
	_tmp2_ = _data6_->format_cmb;
#line 203 "../src/Widgets/SaveDialog.vala"
	_tmp3_ = gtk_combo_box_text_get_active_text (_tmp2_);
#line 203 "../src/Widgets/SaveDialog.vala"
	_tmp4_ = _tmp3_;
#line 203 "../src/Widgets/SaveDialog.vala"
	g_signal_emit (self, screenshot_save_dialog_signals[SCREENSHOT_SAVE_DIALOG_SAVE_RESPONSE_SIGNAL], 0, FALSE, _tmp0_, _tmp1_, _tmp4_);
#line 203 "../src/Widgets/SaveDialog.vala"
	_g_free0 (_tmp4_);
#line 649 "SaveDialog.c"
}

static void
__screenshot_save_dialog___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 202 "../src/Widgets/SaveDialog.vala"
	_screenshot_save_dialog___lambda9_ (self);
#line 658 "SaveDialog.c"
}

static void
_screenshot_save_dialog___lambda10_ (Block6Data* _data6_)
{
	ScreenshotSaveDialog* self;
	GSettings* _tmp0_;
	GtkComboBoxText* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 206 "../src/Widgets/SaveDialog.vala"
	self = _data6_->self;
#line 207 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = self->priv->_settings;
#line 207 "../src/Widgets/SaveDialog.vala"
	_tmp1_ = _data6_->format_cmb;
#line 207 "../src/Widgets/SaveDialog.vala"
	_tmp2_ = gtk_combo_box_text_get_active_text (_tmp1_);
#line 207 "../src/Widgets/SaveDialog.vala"
	_tmp3_ = _tmp2_;
#line 207 "../src/Widgets/SaveDialog.vala"
	g_settings_set_string (_tmp0_, "format", _tmp3_);
#line 207 "../src/Widgets/SaveDialog.vala"
	_g_free0 (_tmp3_);
#line 683 "SaveDialog.c"
}

static void
__screenshot_save_dialog___lambda10__gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
#line 206 "../src/Widgets/SaveDialog.vala"
	_screenshot_save_dialog___lambda10_ (self);
#line 692 "SaveDialog.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 715 "SaveDialog.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 724 "SaveDialog.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 743 "SaveDialog.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 747 "SaveDialog.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 753 "SaveDialog.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 763 "SaveDialog.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 771 "SaveDialog.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 775 "SaveDialog.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 781 "SaveDialog.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 791 "SaveDialog.c"
}

static void
_g_free0_ (gpointer var)
{
#line 210 "../src/Widgets/SaveDialog.vala"
	var = (g_free (var), NULL);
#line 799 "SaveDialog.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 210 "../src/Widgets/SaveDialog.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 807 "SaveDialog.c"
}

static void
_screenshot_save_dialog___lambda11_ (Block6Data* _data6_)
{
	ScreenshotSaveDialog* self;
	GSList* uris = NULL;
	GtkFileChooserButton* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
#line 210 "../src/Widgets/SaveDialog.vala"
	self = _data6_->self;
#line 211 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = _data6_->location;
#line 211 "../src/Widgets/SaveDialog.vala"
	_tmp1_ = gtk_file_chooser_get_uris ((GtkFileChooser*) _tmp0_);
#line 211 "../src/Widgets/SaveDialog.vala"
	uris = _tmp1_;
#line 212 "../src/Widgets/SaveDialog.vala"
	_tmp2_ = uris;
#line 828 "SaveDialog.c"
	{
		GSList* uri_collection = NULL;
		GSList* uri_it = NULL;
#line 212 "../src/Widgets/SaveDialog.vala"
		uri_collection = _tmp2_;
#line 212 "../src/Widgets/SaveDialog.vala"
		for (uri_it = uri_collection; uri_it != NULL; uri_it = uri_it->next) {
#line 836 "SaveDialog.c"
			const gchar* uri = NULL;
#line 212 "../src/Widgets/SaveDialog.vala"
			uri = (const gchar*) uri_it->data;
#line 840 "SaveDialog.c"
			{
				GSettings* _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				GSettings* _tmp9_;
				gchar* _tmp10_;
#line 213 "../src/Widgets/SaveDialog.vala"
				_tmp3_ = self->priv->_settings;
#line 213 "../src/Widgets/SaveDialog.vala"
				_tmp4_ = uri;
#line 213 "../src/Widgets/SaveDialog.vala"
				_tmp5_ = string_substring (_tmp4_, (glong) 7, (glong) -1);
#line 213 "../src/Widgets/SaveDialog.vala"
				_tmp6_ = _tmp5_;
#line 213 "../src/Widgets/SaveDialog.vala"
				_tmp7_ = g_uri_unescape_string (_tmp6_, NULL);
#line 213 "../src/Widgets/SaveDialog.vala"
				_tmp8_ = _tmp7_;
#line 213 "../src/Widgets/SaveDialog.vala"
				g_settings_set_string (_tmp3_, "folder-dir", _tmp8_);
#line 213 "../src/Widgets/SaveDialog.vala"
				_g_free0 (_tmp8_);
#line 213 "../src/Widgets/SaveDialog.vala"
				_g_free0 (_tmp6_);
#line 214 "../src/Widgets/SaveDialog.vala"
				_tmp9_ = self->priv->_settings;
#line 214 "../src/Widgets/SaveDialog.vala"
				_tmp10_ = g_settings_get_string (_tmp9_, "folder-dir");
#line 214 "../src/Widgets/SaveDialog.vala"
				_g_free0 (_data6_->folder_dir);
#line 214 "../src/Widgets/SaveDialog.vala"
				_data6_->folder_dir = _tmp10_;
#line 876 "SaveDialog.c"
			}
		}
	}
#line 210 "../src/Widgets/SaveDialog.vala"
	(uris == NULL) ? NULL : (uris = (_g_slist_free__g_free0_ (uris), NULL));
#line 882 "SaveDialog.c"
}

static void
__screenshot_save_dialog___lambda11__gtk_file_chooser_selection_changed (GtkFileChooser* _sender,
                                                                         gpointer self)
{
#line 210 "../src/Widgets/SaveDialog.vala"
	_screenshot_save_dialog___lambda11_ (self);
#line 891 "SaveDialog.c"
}

static GObject *
screenshot_save_dialog_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScreenshotSaveDialog * self;
	Block6Data* _data6_;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* folder_from_settings = NULL;
	GSettings* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp15_;
	gint width = 0;
	GdkPixbuf* _tmp16_;
	gint height = 0;
	GdkPixbuf* _tmp17_;
	gboolean _tmp18_ = FALSE;
	GdkPixbuf* _tmp19_;
	gint scale = 0;
	GtkStyleContext* _tmp21_;
	GtkImage* preview = NULL;
	GdkPixbuf* _tmp22_;
	GdkPixbuf* _tmp23_;
	GtkImage* _tmp24_ = NULL;
	GtkImage* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkEventBox* preview_event_box = NULL;
	GtkEventBox* _tmp27_;
	GtkEventBox* _tmp28_;
	GtkImage* _tmp29_;
	GtkEventBox* _tmp30_;
	GtkEventBox* _tmp31_;
	GtkEventBox* _tmp32_;
	GThemedIcon* _tmp33_;
	GThemedIcon* _tmp34_;
	GtkEventBox* _tmp35_;
	GtkGrid* preview_box = NULL;
	GtkGrid* _tmp36_ = NULL;
	GtkGrid* _tmp37_;
	GtkEventBox* _tmp38_;
	GtkStyleContext* preview_box_context = NULL;
	GtkGrid* _tmp39_;
	GtkStyleContext* _tmp40_;
	GtkStyleContext* _tmp41_;
	GtkStyleContext* _tmp42_;
	GraniteHeaderLabel* dialog_label = NULL;
	GraniteHeaderLabel* _tmp43_;
	gchar* date_time = NULL;
	GDateTime* _tmp44_;
	GDateTime* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	GraniteHeaderLabel* name_label = NULL;
	GraniteHeaderLabel* _tmp58_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	GraniteValidatedEntry* _tmp61_ = NULL;
	GraniteValidatedEntry* _tmp62_;
	GtkLabel* _tmp63_ = NULL;
	GtkLabel* _tmp64_;
	GtkStyleContext* _tmp65_;
	GtkLabel* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkRevealer* _tmp68_ = NULL;
	GtkRevealer* _tmp69_;
	GtkLabel* _tmp70_;
	GraniteHeaderLabel* format_label = NULL;
	GraniteHeaderLabel* _tmp71_;
	GtkComboBoxText* _tmp72_;
	GtkComboBoxText* _tmp73_;
	GtkComboBoxText* _tmp74_;
	GtkComboBoxText* _tmp75_;
	GtkComboBoxText* _tmp76_;
	GSettings* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	GQuark _tmp81_ = 0U;
#line 132 "../src/Widgets/SaveDialog.vala"
	static GQuark _tmp80_label0 = 0;
#line 132 "../src/Widgets/SaveDialog.vala"
	static GQuark _tmp80_label1 = 0;
#line 132 "../src/Widgets/SaveDialog.vala"
	static GQuark _tmp80_label2 = 0;
#line 132 "../src/Widgets/SaveDialog.vala"
	static GQuark _tmp80_label3 = 0;
#line 994 "SaveDialog.c"
	GraniteHeaderLabel* location_label = NULL;
	GraniteHeaderLabel* _tmp86_ = NULL;
	GtkFileChooserButton* _tmp87_;
	GtkFileChooserButton* _tmp88_;
	const gchar* _tmp89_;
	GtkBox* content = NULL;
	GtkBox* _tmp90_;
	GtkBox* _tmp91_;
	GtkBox* _tmp92_;
	GtkBox* _tmp93_;
	GtkBox* _tmp94_;
	GtkBox* _tmp95_;
	GtkBox* _tmp96_;
	GtkBox* _tmp97_;
	GraniteHeaderLabel* _tmp98_;
	GtkBox* _tmp99_;
	GtkGrid* _tmp100_;
	GtkBox* _tmp101_;
	GraniteHeaderLabel* _tmp102_;
	GtkBox* _tmp103_;
	GraniteValidatedEntry* _tmp104_;
	GtkBox* _tmp105_;
	GtkRevealer* _tmp106_;
	GtkBox* _tmp107_;
	GraniteHeaderLabel* _tmp108_;
	GtkBox* _tmp109_;
	GtkComboBoxText* _tmp110_;
	GtkBox* _tmp111_;
	GraniteHeaderLabel* _tmp112_;
	GtkBox* _tmp113_;
	GtkFileChooserButton* _tmp114_;
	GtkButton* clipboard_btn = NULL;
	GtkWidget* _tmp115_;
	GtkButton* _tmp116_;
	GtkButton* retry_btn = NULL;
	GtkWidget* _tmp117_;
	GtkButton* _tmp118_;
	GtkWidget* _tmp119_;
	GtkButton* _tmp120_;
	GtkButton* _tmp121_;
	GtkButton* _tmp122_;
	GtkStyleContext* _tmp123_;
	GraniteValidatedEntry* _tmp124_;
	GtkButton* _tmp125_;
	GtkButton* _tmp126_;
	GtkButton* _tmp127_;
	GtkComboBoxText* _tmp128_;
	GtkFileChooserButton* _tmp129_;
#line 40 "../src/Widgets/SaveDialog.vala"
	parent_class = G_OBJECT_CLASS (screenshot_save_dialog_parent_class);
#line 40 "../src/Widgets/SaveDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/Widgets/SaveDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialog);
#line 40 "../src/Widgets/SaveDialog.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 40 "../src/Widgets/SaveDialog.vala"
	_data6_->_ref_count_ = 1;
#line 40 "../src/Widgets/SaveDialog.vala"
	_data6_->self = g_object_ref (self);
#line 41 "../src/Widgets/SaveDialog.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 42 "../src/Widgets/SaveDialog.vala"
	_tmp0_ = g_get_user_special_dir (G_USER_DIRECTORY_PICTURES);
#line 42 "../src/Widgets/SaveDialog.vala"
	_tmp1_ = g_strdup_printf ("%c", (gint) G_DIR_SEPARATOR);
#line 42 "../src/Widgets/SaveDialog.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/Widgets/SaveDialog.vala"
	_tmp3_ = g_strconcat (_tmp0_, _tmp2_, NULL);
#line 42 "../src/Widgets/SaveDialog.vala"
	_tmp4_ = _tmp3_;
#line 42 "../src/Widgets/SaveDialog.vala"
	_tmp5_ = g_strconcat (_tmp4_, SCREENSHOT_APPLICATION_SAVE_FOLDER, NULL);
#line 42 "../src/Widgets/SaveDialog.vala"
	_tmp6_ = _tmp5_;
#line 42 "../src/Widgets/SaveDialog.vala"
	_g_free0 (_tmp4_);
#line 42 "../src/Widgets/SaveDialog.vala"
	_g_free0 (_tmp2_);
#line 42 "../src/Widgets/SaveDialog.vala"
	_data6_->folder_dir = _tmp6_;
#line 45 "../src/Widgets/SaveDialog.vala"
	_tmp7_ = self->priv->_settings;
#line 45 "../src/Widgets/SaveDialog.vala"
	_tmp8_ = g_settings_get_string (_tmp7_, "folder-dir");
#line 45 "../src/Widgets/SaveDialog.vala"
	folder_from_settings = _tmp8_;
#line 47 "../src/Widgets/SaveDialog.vala"
	_tmp10_ = folder_from_settings;
#line 47 "../src/Widgets/SaveDialog.vala"
	_tmp11_ = _data6_->folder_dir;
#line 47 "../src/Widgets/SaveDialog.vala"
	if (g_strcmp0 (_tmp10_, _tmp11_) != 0) {
#line 1089 "SaveDialog.c"
		const gchar* _tmp12_;
#line 47 "../src/Widgets/SaveDialog.vala"
		_tmp12_ = folder_from_settings;
#line 47 "../src/Widgets/SaveDialog.vala"
		_tmp9_ = g_strcmp0 (_tmp12_, "") != 0;
#line 1095 "SaveDialog.c"
	} else {
#line 47 "../src/Widgets/SaveDialog.vala"
		_tmp9_ = FALSE;
#line 1099 "SaveDialog.c"
	}
#line 47 "../src/Widgets/SaveDialog.vala"
	if (_tmp9_) {
#line 1103 "SaveDialog.c"
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 48 "../src/Widgets/SaveDialog.vala"
		_tmp13_ = folder_from_settings;
#line 48 "../src/Widgets/SaveDialog.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 48 "../src/Widgets/SaveDialog.vala"
		_g_free0 (_data6_->folder_dir);
#line 48 "../src/Widgets/SaveDialog.vala"
		_data6_->folder_dir = _tmp14_;
#line 1114 "SaveDialog.c"
	}
#line 51 "../src/Widgets/SaveDialog.vala"
	_tmp15_ = _data6_->folder_dir;
#line 51 "../src/Widgets/SaveDialog.vala"
	screenshot_application_create_dir_if_missing (_tmp15_);
#line 53 "../src/Widgets/SaveDialog.vala"
	_tmp16_ = self->priv->_pixbuf;
#line 53 "../src/Widgets/SaveDialog.vala"
	width = gdk_pixbuf_get_width (_tmp16_) / 4;
#line 54 "../src/Widgets/SaveDialog.vala"
	_tmp17_ = self->priv->_pixbuf;
#line 54 "../src/Widgets/SaveDialog.vala"
	height = gdk_pixbuf_get_height (_tmp17_) / 4;
#line 55 "../src/Widgets/SaveDialog.vala"
	_tmp19_ = self->priv->_pixbuf;
#line 55 "../src/Widgets/SaveDialog.vala"
	if (gdk_pixbuf_get_width (_tmp19_) > (gdk_screen_width () / 2)) {
#line 55 "../src/Widgets/SaveDialog.vala"
		_tmp18_ = TRUE;
#line 1134 "SaveDialog.c"
	} else {
		GdkPixbuf* _tmp20_;
#line 55 "../src/Widgets/SaveDialog.vala"
		_tmp20_ = self->priv->_pixbuf;
#line 55 "../src/Widgets/SaveDialog.vala"
		_tmp18_ = gdk_pixbuf_get_height (_tmp20_) > (gdk_screen_height () / 2);
#line 1141 "SaveDialog.c"
	}
#line 55 "../src/Widgets/SaveDialog.vala"
	if (_tmp18_) {
#line 56 "../src/Widgets/SaveDialog.vala"
		width /= 2;
#line 57 "../src/Widgets/SaveDialog.vala"
		height /= 2;
#line 1149 "SaveDialog.c"
	}
#line 60 "../src/Widgets/SaveDialog.vala"
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 60 "../src/Widgets/SaveDialog.vala"
	scale = gtk_style_context_get_scale (_tmp21_);
#line 62 "../src/Widgets/SaveDialog.vala"
	_tmp22_ = self->priv->_pixbuf;
#line 62 "../src/Widgets/SaveDialog.vala"
	_tmp23_ = gdk_pixbuf_scale_simple (_tmp22_, width * scale, height * scale, GDK_INTERP_BILINEAR);
#line 62 "../src/Widgets/SaveDialog.vala"
	_tmp24_ = (GtkImage*) gtk_image_new ();
#line 62 "../src/Widgets/SaveDialog.vala"
	g_object_set (_tmp24_, "gicon", (GIcon*) _tmp23_, NULL);
#line 62 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (_tmp23_);
#line 62 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp24_);
#line 62 "../src/Widgets/SaveDialog.vala"
	preview = _tmp24_;
#line 65 "../src/Widgets/SaveDialog.vala"
	_tmp25_ = preview;
#line 65 "../src/Widgets/SaveDialog.vala"
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
#line 65 "../src/Widgets/SaveDialog.vala"
	gtk_style_context_set_scale (_tmp26_, 1);
#line 67 "../src/Widgets/SaveDialog.vala"
	_tmp27_ = (GtkEventBox*) gtk_event_box_new ();
#line 67 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp27_);
#line 67 "../src/Widgets/SaveDialog.vala"
	preview_event_box = _tmp27_;
#line 68 "../src/Widgets/SaveDialog.vala"
	_tmp28_ = preview_event_box;
#line 68 "../src/Widgets/SaveDialog.vala"
	_tmp29_ = preview;
#line 68 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 70 "../src/Widgets/SaveDialog.vala"
	_tmp30_ = preview_event_box;
#line 70 "../src/Widgets/SaveDialog.vala"
	gtk_drag_source_set ((GtkWidget*) _tmp30_, GDK_BUTTON1_MASK, NULL, (gint) 0, GDK_ACTION_COPY);
#line 71 "../src/Widgets/SaveDialog.vala"
	_tmp31_ = preview_event_box;
#line 71 "../src/Widgets/SaveDialog.vala"
	gtk_drag_source_add_image_targets ((GtkWidget*) _tmp31_);
#line 72 "../src/Widgets/SaveDialog.vala"
	_tmp32_ = preview_event_box;
#line 72 "../src/Widgets/SaveDialog.vala"
	_tmp33_ = (GThemedIcon*) g_themed_icon_new ("image-x-generic");
#line 72 "../src/Widgets/SaveDialog.vala"
	_tmp34_ = _tmp33_;
#line 72 "../src/Widgets/SaveDialog.vala"
	gtk_drag_source_set_icon_gicon ((GtkWidget*) _tmp32_, (GIcon*) _tmp34_);
#line 72 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (_tmp34_);
#line 73 "../src/Widgets/SaveDialog.vala"
	_tmp35_ = preview_event_box;
#line 73 "../src/Widgets/SaveDialog.vala"
	g_signal_connect_object ((GtkWidget*) _tmp35_, "drag-data-get", (GCallback) __screenshot_save_dialog___lambda5__gtk_widget_drag_data_get, self, 0);
#line 77 "../src/Widgets/SaveDialog.vala"
	_tmp36_ = (GtkGrid*) gtk_grid_new ();
#line 77 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp36_, 18);
#line 77 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp36_, 18);
#line 77 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp36_, GTK_ALIGN_CENTER);
#line 77 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp36_);
#line 77 "../src/Widgets/SaveDialog.vala"
	preview_box = _tmp36_;
#line 82 "../src/Widgets/SaveDialog.vala"
	_tmp37_ = preview_box;
#line 82 "../src/Widgets/SaveDialog.vala"
	_tmp38_ = preview_event_box;
#line 82 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 84 "../src/Widgets/SaveDialog.vala"
	_tmp39_ = preview_box;
#line 84 "../src/Widgets/SaveDialog.vala"
	_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) _tmp39_);
#line 84 "../src/Widgets/SaveDialog.vala"
	preview_box_context = _tmp40_;
#line 85 "../src/Widgets/SaveDialog.vala"
	_tmp41_ = preview_box_context;
#line 85 "../src/Widgets/SaveDialog.vala"
	gtk_style_context_add_class (_tmp41_, GRANITE_STYLE_CLASS_CARD);
#line 86 "../src/Widgets/SaveDialog.vala"
	_tmp42_ = preview_box_context;
#line 86 "../src/Widgets/SaveDialog.vala"
	gtk_style_context_add_class (_tmp42_, GRANITE_STYLE_CLASS_CHECKERBOARD);
#line 88 "../src/Widgets/SaveDialog.vala"
	_tmp43_ = granite_header_label_new (_ ("Save Image as…"));
#line 88 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp43_);
#line 88 "../src/Widgets/SaveDialog.vala"
	dialog_label = _tmp43_;
#line 90 "../src/Widgets/SaveDialog.vala"
	_tmp44_ = g_date_time_new_now_local ();
#line 90 "../src/Widgets/SaveDialog.vala"
	_tmp45_ = _tmp44_;
#line 90 "../src/Widgets/SaveDialog.vala"
	_tmp46_ = g_date_time_format (_tmp45_, "%Y-%m-%d %H.%M.%S");
#line 90 "../src/Widgets/SaveDialog.vala"
	_tmp47_ = _tmp46_;
#line 90 "../src/Widgets/SaveDialog.vala"
	_g_date_time_unref0 (_tmp45_);
#line 90 "../src/Widgets/SaveDialog.vala"
	date_time = _tmp47_;
#line 93 "../src/Widgets/SaveDialog.vala"
	_tmp48_ = date_time;
#line 93 "../src/Widgets/SaveDialog.vala"
	_tmp49_ = g_strdup_printf (_ ("Screenshot from %s"), _tmp48_);
#line 93 "../src/Widgets/SaveDialog.vala"
	_data6_->file_name = _tmp49_;
#line 95 "../src/Widgets/SaveDialog.vala"
	_tmp50_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 95 "../src/Widgets/SaveDialog.vala"
	_tmp51_ = _tmp50_;
#line 95 "../src/Widgets/SaveDialog.vala"
	if (_tmp51_ > 1) {
#line 1271 "SaveDialog.c"
		const gchar* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 96 "../src/Widgets/SaveDialog.vala"
		_tmp52_ = _data6_->file_name;
#line 96 "../src/Widgets/SaveDialog.vala"
		_tmp53_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 96 "../src/Widgets/SaveDialog.vala"
		_tmp54_ = _tmp53_;
#line 96 "../src/Widgets/SaveDialog.vala"
		_tmp55_ = g_strdup_printf ("@%ix", _tmp54_);
#line 96 "../src/Widgets/SaveDialog.vala"
		_tmp56_ = _tmp55_;
#line 96 "../src/Widgets/SaveDialog.vala"
		_tmp57_ = g_strconcat (_tmp52_, _tmp56_, NULL);
#line 96 "../src/Widgets/SaveDialog.vala"
		_g_free0 (_data6_->file_name);
#line 96 "../src/Widgets/SaveDialog.vala"
		_data6_->file_name = _tmp57_;
#line 96 "../src/Widgets/SaveDialog.vala"
		_g_free0 (_tmp56_);
#line 1296 "SaveDialog.c"
	}
#line 99 "../src/Widgets/SaveDialog.vala"
	_tmp58_ = granite_header_label_new (_ ("Name"));
#line 99 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp58_);
#line 99 "../src/Widgets/SaveDialog.vala"
	name_label = _tmp58_;
#line 101 "../src/Widgets/SaveDialog.vala"
	_tmp59_ = _data6_->file_name;
#line 101 "../src/Widgets/SaveDialog.vala"
	_tmp60_ = g_strdup (_tmp59_);
#line 101 "../src/Widgets/SaveDialog.vala"
	_tmp61_ = granite_validated_entry_new ();
#line 101 "../src/Widgets/SaveDialog.vala"
	gtk_entry_set_activates_default ((GtkEntry*) _tmp61_, TRUE);
#line 101 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp61_, TRUE);
#line 101 "../src/Widgets/SaveDialog.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp61_, _tmp60_);
#line 101 "../src/Widgets/SaveDialog.vala"
	_g_free0 (_tmp60_);
#line 101 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp61_);
#line 101 "../src/Widgets/SaveDialog.vala"
	_data6_->name_entry = _tmp61_;
#line 106 "../src/Widgets/SaveDialog.vala"
	_tmp62_ = _data6_->name_entry;
#line 106 "../src/Widgets/SaveDialog.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp62_);
#line 108 "../src/Widgets/SaveDialog.vala"
	_tmp63_ = (GtkLabel*) gtk_label_new ("");
#line 108 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp63_, GTK_ALIGN_END);
#line 108 "../src/Widgets/SaveDialog.vala"
	gtk_label_set_justify (_tmp63_, GTK_JUSTIFY_RIGHT);
#line 108 "../src/Widgets/SaveDialog.vala"
	gtk_label_set_max_width_chars (_tmp63_, 55);
#line 108 "../src/Widgets/SaveDialog.vala"
	g_object_set (_tmp63_, "wrap", TRUE, NULL);
#line 108 "../src/Widgets/SaveDialog.vala"
	gtk_label_set_xalign (_tmp63_, (gfloat) 1);
#line 108 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp63_);
#line 108 "../src/Widgets/SaveDialog.vala"
	_data6_->validation_label = _tmp63_;
#line 115 "../src/Widgets/SaveDialog.vala"
	_tmp64_ = _data6_->validation_label;
#line 115 "../src/Widgets/SaveDialog.vala"
	_tmp65_ = gtk_widget_get_style_context ((GtkWidget*) _tmp64_);
#line 115 "../src/Widgets/SaveDialog.vala"
	gtk_style_context_add_class (_tmp65_, GRANITE_STYLE_CLASS_SMALL_LABEL);
#line 116 "../src/Widgets/SaveDialog.vala"
	_tmp66_ = _data6_->validation_label;
#line 116 "../src/Widgets/SaveDialog.vala"
	_tmp67_ = gtk_widget_get_style_context ((GtkWidget*) _tmp66_);
#line 116 "../src/Widgets/SaveDialog.vala"
	gtk_style_context_add_class (_tmp67_, GTK_STYLE_CLASS_ERROR);
#line 118 "../src/Widgets/SaveDialog.vala"
	_tmp68_ = (GtkRevealer*) gtk_revealer_new ();
#line 118 "../src/Widgets/SaveDialog.vala"
	gtk_revealer_set_transition_type (_tmp68_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 118 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp68_, 3);
#line 118 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp68_);
#line 118 "../src/Widgets/SaveDialog.vala"
	_data6_->name_message_revealer = _tmp68_;
#line 122 "../src/Widgets/SaveDialog.vala"
	_tmp69_ = _data6_->name_message_revealer;
#line 122 "../src/Widgets/SaveDialog.vala"
	_tmp70_ = _data6_->validation_label;
#line 122 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp69_, (GtkWidget*) _tmp70_);
#line 124 "../src/Widgets/SaveDialog.vala"
	_tmp71_ = granite_header_label_new (_ ("File Type"));
#line 124 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp71_);
#line 124 "../src/Widgets/SaveDialog.vala"
	format_label = _tmp71_;
#line 126 "../src/Widgets/SaveDialog.vala"
	_tmp72_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 126 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp72_);
#line 126 "../src/Widgets/SaveDialog.vala"
	_data6_->format_cmb = _tmp72_;
#line 127 "../src/Widgets/SaveDialog.vala"
	_tmp73_ = _data6_->format_cmb;
#line 127 "../src/Widgets/SaveDialog.vala"
	gtk_combo_box_text_append_text (_tmp73_, "png");
#line 128 "../src/Widgets/SaveDialog.vala"
	_tmp74_ = _data6_->format_cmb;
#line 128 "../src/Widgets/SaveDialog.vala"
	gtk_combo_box_text_append_text (_tmp74_, "jpeg");
#line 129 "../src/Widgets/SaveDialog.vala"
	_tmp75_ = _data6_->format_cmb;
#line 129 "../src/Widgets/SaveDialog.vala"
	gtk_combo_box_text_append_text (_tmp75_, "bmp");
#line 130 "../src/Widgets/SaveDialog.vala"
	_tmp76_ = _data6_->format_cmb;
#line 130 "../src/Widgets/SaveDialog.vala"
	gtk_combo_box_text_append_text (_tmp76_, "tiff");
#line 132 "../src/Widgets/SaveDialog.vala"
	_tmp77_ = self->priv->_settings;
#line 132 "../src/Widgets/SaveDialog.vala"
	_tmp78_ = g_settings_get_string (_tmp77_, "format");
#line 132 "../src/Widgets/SaveDialog.vala"
	_tmp79_ = _tmp78_;
#line 132 "../src/Widgets/SaveDialog.vala"
	_tmp81_ = (NULL == _tmp79_) ? 0 : g_quark_from_string (_tmp79_);
#line 132 "../src/Widgets/SaveDialog.vala"
	g_free (_tmp79_);
#line 132 "../src/Widgets/SaveDialog.vala"
	if (_tmp81_ == ((0 != _tmp80_label0) ? _tmp80_label0 : (_tmp80_label0 = g_quark_from_static_string ("png")))) {
#line 132 "../src/Widgets/SaveDialog.vala"
		switch (0) {
#line 1412 "SaveDialog.c"
			default:
			{
				GtkComboBoxText* _tmp82_;
#line 134 "../src/Widgets/SaveDialog.vala"
				_tmp82_ = _data6_->format_cmb;
#line 134 "../src/Widgets/SaveDialog.vala"
				gtk_combo_box_set_active ((GtkComboBox*) _tmp82_, 0);
#line 135 "../src/Widgets/SaveDialog.vala"
				break;
#line 1422 "SaveDialog.c"
			}
		}
	} else if (_tmp81_ == ((0 != _tmp80_label1) ? _tmp80_label1 : (_tmp80_label1 = g_quark_from_static_string ("jpeg")))) {
#line 132 "../src/Widgets/SaveDialog.vala"
		switch (0) {
#line 1428 "SaveDialog.c"
			default:
			{
				GtkComboBoxText* _tmp83_;
#line 137 "../src/Widgets/SaveDialog.vala"
				_tmp83_ = _data6_->format_cmb;
#line 137 "../src/Widgets/SaveDialog.vala"
				gtk_combo_box_set_active ((GtkComboBox*) _tmp83_, 1);
#line 138 "../src/Widgets/SaveDialog.vala"
				break;
#line 1438 "SaveDialog.c"
			}
		}
	} else if (_tmp81_ == ((0 != _tmp80_label2) ? _tmp80_label2 : (_tmp80_label2 = g_quark_from_static_string ("bmp")))) {
#line 132 "../src/Widgets/SaveDialog.vala"
		switch (0) {
#line 1444 "SaveDialog.c"
			default:
			{
				GtkComboBoxText* _tmp84_;
#line 140 "../src/Widgets/SaveDialog.vala"
				_tmp84_ = _data6_->format_cmb;
#line 140 "../src/Widgets/SaveDialog.vala"
				gtk_combo_box_set_active ((GtkComboBox*) _tmp84_, 2);
#line 141 "../src/Widgets/SaveDialog.vala"
				break;
#line 1454 "SaveDialog.c"
			}
		}
	} else if (_tmp81_ == ((0 != _tmp80_label3) ? _tmp80_label3 : (_tmp80_label3 = g_quark_from_static_string ("tiff")))) {
#line 132 "../src/Widgets/SaveDialog.vala"
		switch (0) {
#line 1460 "SaveDialog.c"
			default:
			{
				GtkComboBoxText* _tmp85_;
#line 143 "../src/Widgets/SaveDialog.vala"
				_tmp85_ = _data6_->format_cmb;
#line 143 "../src/Widgets/SaveDialog.vala"
				gtk_combo_box_set_active ((GtkComboBox*) _tmp85_, 3);
#line 144 "../src/Widgets/SaveDialog.vala"
				break;
#line 1470 "SaveDialog.c"
			}
		}
	}
#line 147 "../src/Widgets/SaveDialog.vala"
	_tmp86_ = granite_header_label_new (_ ("Folder"));
#line 147 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp86_, 18);
#line 147 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp86_);
#line 147 "../src/Widgets/SaveDialog.vala"
	location_label = _tmp86_;
#line 151 "../src/Widgets/SaveDialog.vala"
	_tmp87_ = (GtkFileChooserButton*) gtk_file_chooser_button_new (_ ("Select Screenshots Folder…"), GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
#line 151 "../src/Widgets/SaveDialog.vala"
	g_object_ref_sink (_tmp87_);
#line 151 "../src/Widgets/SaveDialog.vala"
	_data6_->location = _tmp87_;
#line 152 "../src/Widgets/SaveDialog.vala"
	_tmp88_ = _data6_->location;
#line 152 "../src/Widgets/SaveDialog.vala"
	_tmp89_ = _data6_->folder_dir;
#line 152 "../src/Widgets/SaveDialog.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp88_, _tmp89_);
#line 154 "../src/Widgets/SaveDialog.vala"
	_tmp90_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 154 "../src/Widgets/SaveDialog.vala"
	_tmp91_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp90_, gtk_box_get_type ()) ? ((GtkBox*) _tmp90_) : NULL);
#line 154 "../src/Widgets/SaveDialog.vala"
	content = _tmp91_;
#line 155 "../src/Widgets/SaveDialog.vala"
	_tmp92_ = content;
#line 155 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp92_, GTK_ALIGN_START);
#line 156 "../src/Widgets/SaveDialog.vala"
	_tmp93_ = content;
#line 156 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp93_, TRUE);
#line 157 "../src/Widgets/SaveDialog.vala"
	_tmp94_ = content;
#line 157 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp94_, 12);
#line 158 "../src/Widgets/SaveDialog.vala"
	_tmp95_ = content;
#line 158 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp95_, 12);
#line 159 "../src/Widgets/SaveDialog.vala"
	_tmp96_ = content;
#line 159 "../src/Widgets/SaveDialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp96_, 12);
#line 160 "../src/Widgets/SaveDialog.vala"
	_tmp97_ = content;
#line 160 "../src/Widgets/SaveDialog.vala"
	_tmp98_ = dialog_label;
#line 160 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp97_, (GtkWidget*) _tmp98_);
#line 161 "../src/Widgets/SaveDialog.vala"
	_tmp99_ = content;
#line 161 "../src/Widgets/SaveDialog.vala"
	_tmp100_ = preview_box;
#line 161 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp99_, (GtkWidget*) _tmp100_);
#line 162 "../src/Widgets/SaveDialog.vala"
	_tmp101_ = content;
#line 162 "../src/Widgets/SaveDialog.vala"
	_tmp102_ = name_label;
#line 162 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp101_, (GtkWidget*) _tmp102_);
#line 163 "../src/Widgets/SaveDialog.vala"
	_tmp103_ = content;
#line 163 "../src/Widgets/SaveDialog.vala"
	_tmp104_ = _data6_->name_entry;
#line 163 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp103_, (GtkWidget*) _tmp104_);
#line 164 "../src/Widgets/SaveDialog.vala"
	_tmp105_ = content;
#line 164 "../src/Widgets/SaveDialog.vala"
	_tmp106_ = _data6_->name_message_revealer;
#line 164 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp105_, (GtkWidget*) _tmp106_);
#line 165 "../src/Widgets/SaveDialog.vala"
	_tmp107_ = content;
#line 165 "../src/Widgets/SaveDialog.vala"
	_tmp108_ = format_label;
#line 165 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp107_, (GtkWidget*) _tmp108_);
#line 166 "../src/Widgets/SaveDialog.vala"
	_tmp109_ = content;
#line 166 "../src/Widgets/SaveDialog.vala"
	_tmp110_ = _data6_->format_cmb;
#line 166 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp109_, (GtkWidget*) _tmp110_);
#line 167 "../src/Widgets/SaveDialog.vala"
	_tmp111_ = content;
#line 167 "../src/Widgets/SaveDialog.vala"
	_tmp112_ = location_label;
#line 167 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp111_, (GtkWidget*) _tmp112_);
#line 168 "../src/Widgets/SaveDialog.vala"
	_tmp113_ = content;
#line 168 "../src/Widgets/SaveDialog.vala"
	_tmp114_ = _data6_->location;
#line 168 "../src/Widgets/SaveDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp113_, (GtkWidget*) _tmp114_);
#line 170 "../src/Widgets/SaveDialog.vala"
	_tmp115_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Copy to Clipboard"), 0);
#line 170 "../src/Widgets/SaveDialog.vala"
	_tmp116_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp115_, gtk_button_get_type (), GtkButton));
#line 170 "../src/Widgets/SaveDialog.vala"
	clipboard_btn = _tmp116_;
#line 172 "../src/Widgets/SaveDialog.vala"
	_tmp117_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 172 "../src/Widgets/SaveDialog.vala"
	_tmp118_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp117_, gtk_button_get_type (), GtkButton));
#line 172 "../src/Widgets/SaveDialog.vala"
	retry_btn = _tmp118_;
#line 174 "../src/Widgets/SaveDialog.vala"
	_tmp119_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Save"), (gint) GTK_RESPONSE_APPLY);
#line 174 "../src/Widgets/SaveDialog.vala"
	_tmp120_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp119_, gtk_button_get_type (), GtkButton));
#line 174 "../src/Widgets/SaveDialog.vala"
	_data6_->save_btn = _tmp120_;
#line 175 "../src/Widgets/SaveDialog.vala"
	_tmp121_ = _data6_->save_btn;
#line 175 "../src/Widgets/SaveDialog.vala"
	g_object_set ((GtkWidget*) _tmp121_, "has-default", TRUE, NULL);
#line 176 "../src/Widgets/SaveDialog.vala"
	_tmp122_ = _data6_->save_btn;
#line 176 "../src/Widgets/SaveDialog.vala"
	_tmp123_ = gtk_widget_get_style_context ((GtkWidget*) _tmp122_);
#line 176 "../src/Widgets/SaveDialog.vala"
	gtk_style_context_add_class (_tmp123_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 178 "../src/Widgets/SaveDialog.vala"
	_tmp124_ = _data6_->name_entry;
#line 178 "../src/Widgets/SaveDialog.vala"
	g_signal_connect_data ((GtkEditable*) _tmp124_, "changed", (GCallback) __screenshot_save_dialog___lambda6__gtk_editable_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 193 "../src/Widgets/SaveDialog.vala"
	_tmp125_ = _data6_->save_btn;
#line 193 "../src/Widgets/SaveDialog.vala"
	g_signal_connect_data (_tmp125_, "clicked", (GCallback) __screenshot_save_dialog___lambda7__gtk_button_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 197 "../src/Widgets/SaveDialog.vala"
	_tmp126_ = clipboard_btn;
#line 197 "../src/Widgets/SaveDialog.vala"
	g_signal_connect_object (_tmp126_, "clicked", (GCallback) __screenshot_save_dialog___lambda8__gtk_button_clicked, self, 0);
#line 202 "../src/Widgets/SaveDialog.vala"
	_tmp127_ = retry_btn;
#line 202 "../src/Widgets/SaveDialog.vala"
	g_signal_connect_data (_tmp127_, "clicked", (GCallback) __screenshot_save_dialog___lambda9__gtk_button_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 206 "../src/Widgets/SaveDialog.vala"
	_tmp128_ = _data6_->format_cmb;
#line 206 "../src/Widgets/SaveDialog.vala"
	g_signal_connect_data ((GtkComboBox*) _tmp128_, "changed", (GCallback) __screenshot_save_dialog___lambda10__gtk_combo_box_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 210 "../src/Widgets/SaveDialog.vala"
	_tmp129_ = _data6_->location;
#line 210 "../src/Widgets/SaveDialog.vala"
	g_signal_connect_data ((GtkFileChooser*) _tmp129_, "selection-changed", (GCallback) __screenshot_save_dialog___lambda11__gtk_file_chooser_selection_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (retry_btn);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (clipboard_btn);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (content);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (location_label);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (format_label);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (name_label);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_free0 (date_time);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (dialog_label);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (preview_box);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (preview_event_box);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (preview);
#line 40 "../src/Widgets/SaveDialog.vala"
	_g_free0 (folder_from_settings);
#line 40 "../src/Widgets/SaveDialog.vala"
	block6_data_unref (_data6_);
#line 40 "../src/Widgets/SaveDialog.vala"
	_data6_ = NULL;
#line 40 "../src/Widgets/SaveDialog.vala"
	return obj;
#line 1656 "SaveDialog.c"
}

static void
screenshot_save_dialog_class_init (ScreenshotSaveDialogClass * klass,
                                   gpointer klass_data)
{
#line 23 "../src/Widgets/SaveDialog.vala"
	screenshot_save_dialog_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/SaveDialog.vala"
	g_type_class_adjust_private_offset (klass, &ScreenshotSaveDialog_private_offset);
#line 23 "../src/Widgets/SaveDialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_screenshot_save_dialog_get_property;
#line 23 "../src/Widgets/SaveDialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_screenshot_save_dialog_set_property;
#line 23 "../src/Widgets/SaveDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = screenshot_save_dialog_constructor;
#line 23 "../src/Widgets/SaveDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = screenshot_save_dialog_finalize;
#line 23 "../src/Widgets/SaveDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREENSHOT_SAVE_DIALOG_PIXBUF_PROPERTY, screenshot_save_dialog_properties[SCREENSHOT_SAVE_DIALOG_PIXBUF_PROPERTY] = g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Widgets/SaveDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREENSHOT_SAVE_DIALOG_SETTINGS_PROPERTY, screenshot_save_dialog_properties[SCREENSHOT_SAVE_DIALOG_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Widgets/SaveDialog.vala"
	screenshot_save_dialog_signals[SCREENSHOT_SAVE_DIALOG_SAVE_RESPONSE_SIGNAL] = g_signal_new ("save-response", SCREENSHOT_TYPE_SAVE_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_STRING_STRING_STRING, G_TYPE_NONE, 4, G_TYPE_BOOLEAN, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
#line 1681 "SaveDialog.c"
}

static void
screenshot_save_dialog_instance_init (ScreenshotSaveDialog * self,
                                      gpointer klass)
{
#line 23 "../src/Widgets/SaveDialog.vala"
	self->priv = screenshot_save_dialog_get_instance_private (self);
#line 1690 "SaveDialog.c"
}

static void
screenshot_save_dialog_finalize (GObject * obj)
{
	ScreenshotSaveDialog * self;
#line 23 "../src/Widgets/SaveDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialog);
#line 24 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (self->priv->_pixbuf);
#line 25 "../src/Widgets/SaveDialog.vala"
	_g_object_unref0 (self->priv->_settings);
#line 23 "../src/Widgets/SaveDialog.vala"
	G_OBJECT_CLASS (screenshot_save_dialog_parent_class)->finalize (obj);
#line 1705 "SaveDialog.c"
}

static GType
screenshot_save_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScreenshotSaveDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) screenshot_save_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScreenshotSaveDialog), 0, (GInstanceInitFunc) screenshot_save_dialog_instance_init, NULL };
	GType screenshot_save_dialog_type_id;
	screenshot_save_dialog_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "ScreenshotSaveDialog", &g_define_type_info, 0);
	ScreenshotSaveDialog_private_offset = g_type_add_instance_private (screenshot_save_dialog_type_id, sizeof (ScreenshotSaveDialogPrivate));
	return screenshot_save_dialog_type_id;
}

GType
screenshot_save_dialog_get_type (void)
{
	static volatile gsize screenshot_save_dialog_type_id__once = 0;
	if (g_once_init_enter (&screenshot_save_dialog_type_id__once)) {
		GType screenshot_save_dialog_type_id;
		screenshot_save_dialog_type_id = screenshot_save_dialog_get_type_once ();
		g_once_init_leave (&screenshot_save_dialog_type_id__once, screenshot_save_dialog_type_id);
	}
	return screenshot_save_dialog_type_id__once;
}

static void
_vala_screenshot_save_dialog_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	ScreenshotSaveDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialog);
#line 23 "../src/Widgets/SaveDialog.vala"
	switch (property_id) {
#line 23 "../src/Widgets/SaveDialog.vala"
		case SCREENSHOT_SAVE_DIALOG_PIXBUF_PROPERTY:
#line 23 "../src/Widgets/SaveDialog.vala"
		g_value_set_object (value, screenshot_save_dialog_get_pixbuf (self));
#line 23 "../src/Widgets/SaveDialog.vala"
		break;
#line 23 "../src/Widgets/SaveDialog.vala"
		case SCREENSHOT_SAVE_DIALOG_SETTINGS_PROPERTY:
#line 23 "../src/Widgets/SaveDialog.vala"
		g_value_set_object (value, screenshot_save_dialog_get_settings (self));
#line 23 "../src/Widgets/SaveDialog.vala"
		break;
#line 1752 "SaveDialog.c"
		default:
#line 23 "../src/Widgets/SaveDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/SaveDialog.vala"
		break;
#line 1758 "SaveDialog.c"
	}
}

static void
_vala_screenshot_save_dialog_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	ScreenshotSaveDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialog);
#line 23 "../src/Widgets/SaveDialog.vala"
	switch (property_id) {
#line 23 "../src/Widgets/SaveDialog.vala"
		case SCREENSHOT_SAVE_DIALOG_PIXBUF_PROPERTY:
#line 23 "../src/Widgets/SaveDialog.vala"
		screenshot_save_dialog_set_pixbuf (self, g_value_get_object (value));
#line 23 "../src/Widgets/SaveDialog.vala"
		break;
#line 23 "../src/Widgets/SaveDialog.vala"
		case SCREENSHOT_SAVE_DIALOG_SETTINGS_PROPERTY:
#line 23 "../src/Widgets/SaveDialog.vala"
		screenshot_save_dialog_set_settings (self, g_value_get_object (value));
#line 23 "../src/Widgets/SaveDialog.vala"
		break;
#line 1784 "SaveDialog.c"
		default:
#line 23 "../src/Widgets/SaveDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/SaveDialog.vala"
		break;
#line 1790 "SaveDialog.c"
	}
}

